package Statusmon::HTMLLog;

use Statusmon::Statusmon;

@Statusmon::HTMLLog::ISA = qw(Statusmon::Statusmon);


sub new
{

    my ($this) = @_;
    my  $class = ref($this) || $this;
    my  $self = {};

    bless($self, $class);

    $self->{"statedir"} = "$main::root/www/logs";
    $self->register( "config" );
    return($self);
}


sub start {
    my( $self ) = @_;
    if( $self->getarg( "immediate" ) =~ /^(yes|ja|true)/i ) {
	$self->register( "status" );
    }
    else {
	$self->register( "statuschange" );
	$self->register( "textchange" );
    }
    $self->register( "config" );
    my $config = $self->get_feature_provider( "displayconfig" );
    if( $config ) { $self->read_config( $config->get_current_config() ) };
}
    

sub read_config {
    my( $self, $newconfig, $oldconfig ) = @_;

    $self->{"config"} = $newconfig;
    $self->register( "-status", "-statuschange", "-textchange" );
    if( $newconfig->{"options"}->{"ImmediateHTML"} ) {
        $self->register( "status" );
    }
    else {
	$self->register( "statuschange" );
	$self->register( "textchange" );
    }
}



sub event {
    my( $self, $cmd ) = @_;

    return if( $cmd->{"id"} eq $self->{"lastid"} );
    print STDERR "Statusmon::HTMLLog got ".($cmd->{"cmd"})." event\n" if( $main::dl>6 );

    if( grep( $_ eq $cmd->{"cmd"}, "status", "statuschange", "textchange" ) ) {
	print STDERR "event: ".($cmd->{"cmd"})."\n";
	$Statusmon::display->write_html_status( 
	    $cmd->{"host"},
	    $cmd->{"check"},
	    $cmd->{"statuscode"},
	    $cmd->{"rawtext"},
	    $cmd->{"statussince"},
	    $self->{"config"}->{"logskin"});
	$self->{"lastid"} = $cmd->{"id"};
    }
    elsif( $cmd->{"cmd"} eq "displayconfig" ) {
	$self->read_config( $cmd->{"config"}, $cmd->{"previous_config"} );
    }
}

