package bbdisp;


use Socket;
use strict;
use FileHandle;

sub new
{
    my ($this, $cfg) = @_;
    my  $class = ref($this) || $this;
    my  $self = {};

    bless($self, $class);
    $self->init;
    $self->{"dir"} = $main::root."/www";
    return $self;
}


sub init {
    my( $self ) = @_;
}



sub write_html_status {
    my( $self, $group, $item, $state, $text, $date, $skin ) = @_;
    my( %vars, $html );

    print "skin: $skin\n";
    $vars{"HOST"} = $group;
    $vars{"ITEM"} = $item;
    if( $text =~ /^(.*?:\d\d \d{2,4})/ ) {
	$vars{"DATE"} = $1;
	$text = $';
    }
    $text =~ s/\|\>/\n/g;
    $html = "";
    if ($text =~ /^(.*?)\&html/s) {
	# Client has told us it understands html
	($text,$html) = ($1,$');
	$html =~ s/\&html//g;
    }
    $text =~ s/\</\&lt;/g;
    $text =~ s/\>/\&gt;/g;
    $text =~ s/^[\s\n]+//;
    $text =~ s/\n/\<BR\>/g;
    $text =~ s/\@/\@\@/g;
    $text =~ s/\&(green|yellow|red|purple)/\@\(lamp.sub:$1\)\@/g;
    $text = $text.$html;
    $skin->{"_BASE"} = "..";
    $vars{"STATUS"} = $main::status_texts{$state};
    $vars{"TEXT"} = $text;
    $vars{"TIME"} = localtime( time );
    $vars{"LASTCHANGE"} = localtime( $date );
    $vars{"BGROUND"} = $main::status_texts{$state};
    $vars{"TEXT"} = $self->replace_vars( $skin, \%vars, $skin->{"loghtml_text.proto"} );
    $self->replace_vars_file( $skin, \%vars, $skin->{"loghtml.proto"}, $self->{"dir"}."/html/".$group.".$item.html" );
    delete $skin->{"_BASE"};
}







sub replace_vars_file {
    my( $self, $skin, $vars, $template, $file ) = @_;
    my( $tmp );

    print STDERR "replace_vars_file -> $file\n" if( $main::dl>3 );
    $tmp = $file.".$$";
    unless( open( OUT, ">$tmp" ) ) {
	print STDERR "$main'prog: cannot create state file $file\n";
	return;
    }
    my $txt = $self->replace_vars( $skin, $vars, $template );
    $txt =~ s/\@\@/\@/g;
    print OUT $txt;
    close OUT;
    unless( Platform::replace( $tmp, $file ) ) {
	main::log( "err", "could not replace $file" );
	# just in case ...
	unlink( $tmp );
	return 0;
    }
    return 1;
}



sub replace_vars {
    my( $self, $skin, $vars, $template ) = @_;

    print STDERR "replace_vars()\n" if( $main::dl>4 );
    my @repl = &_replace_vars( $self, $skin, $vars, $template, 0 );
    return ($repl[0].$repl[1]);
}


sub _replace_vars {
    my( $self, $skin, $vars, $template, $depth, $localvars ) = @_;
    my( $replaced );

    print STDERR "_replace_vars()\n" if( $main::dl>6 );
    $replaced = "";
    while( $template =~ /^(.*?)@/s ) {
	my $what = "\@";
	my $rest = $';
	my $pre = $1;
	my $next = substr( $rest, 0, 1 );
	if( substr( $pre, length($pre)-1 ) eq ")" ) {
	    $pre = substr( $1, 0, length($pre)-1 );
	    $what = ")\@";
	}
	elsif( ($next eq "(") || ($next eq "\@") ) {
	    $what .= $next;
	    $rest = substr( $rest, 1 );
	}
	$replaced .= $pre;
	$template = $rest;
	if( $what eq "\@\@" ) {
	    # @@ means '@'
	    $replaced .= "\@\@";
	    print STDERR "  found \@\n" if( $main::dl>7 );
	}
	elsif( $what eq "\@" ) {
	    # @variable@ -> replace variable by value
	    if( $template =~ /^([a-z0-9_\-\.]+)\@/i ) {
		$template = $';
		print STDERR "  found var $1\n" if( $main::dl>7 );
		$replaced .= $self->_one_var( $skin, $vars, $1, $depth, $localvars );
	    }
	    else {
		$replaced .= "\@";
		print STDERR "  found quote \@\n" if( $main::dl>7 );
	    }
	}
	elsif( $what eq ")\@" ) {
	    if( $depth ) {
		print STDERR "  found end_var )\@\n" if( $main::dl>7 );
		return( $replaced, $template );
	    }
	    print STDERR "  found quoted )\@\n" if( $main::dl>7 );
	    $replaced .= $what;
	}
	else {
	    my( $var );
	    print STDERR "  found nested \@(\n" if( $main::dl>7 );
	    ( $var, $template ) = $self->_replace_vars( $skin, $vars, $template, $depth+1, $localvars );
	    print STDERR "  var is $var\n" if( $main::dl>7 );
	    $replaced .= $self->_one_var( $skin, $vars, $var, $depth, $localvars );
	}
    }
    return( $replaced, $template );
}



sub _one_var {
    my( $self, $skin, $vars, $var, $depth, $localvars ) = @_;
    my( @args, $i );

    print STDERR "    _one_var( $var )\n" if( $main::dl>7 );
    @args = split( ":", $var );
    $var = shift @args;
    if( defined $localvars->{$var} ) {
	$var = $localvars->{$var};
    }
    elsif( defined $vars->{$var} ) {
	$var = $vars->{$var};
    }
    else {
	$var = $self->get_skin( $skin, $var );
    }
    $localvars = {};
    for( $i=0; $i<=$#args; $i++ ) {
	$localvars->{"ARG$i"} = $args[$i];
    }
    my( $a, $b ) = $self->_replace_vars( $skin, $vars, $var, $depth, $localvars );
    return ($a.$b);
}





sub get_skin {
    my( $self, $skin, $what ) = @_;

    return undef unless( defined $skin->{$what} );
    if( $skin->{"T.".$what} ne "url" ) {
	return( $skin->{$what} );
    }
    my $text = $skin->{$what};
    if( (substr( $text, 0, 1 ) ne "/") && (defined $skin->{"_BASE"}) ) {
	return( $skin->{"_BASE"}."/".$text );
    }
    return $text;
}


sub find_skin {
    my( $self, $name ) = @_;
    my( $dir, $fname );

    print STDERR "find_skin( $name )\n" if( $main::dl>5 );
    foreach $dir ( $main::root."etc/skins/", $main::root."/www/skins/" ) {
	$fname = $dir.$name."/" if( -d $dir.$name );
    }
    return( $fname );
}


sub bypass_skincache {
    my( $self, $bypass ) = @_;
    $self->{"bypass_skincache"} = ! $bypass;
}


sub read_skin {
    my( $self, $name, $skin ) = @_;
    my( $fname, $file );

    print STDERR "read_skin( $name )\n" if( $main::dl>2 );
    if( ($name eq "default") && (! $skin) && (defined $self->{"defaultskin"}) ) {
	$skin = $self->{"defaultskin"};
	my %skin = %$skin;
	return( \%skin );
    }
    $skin = {} unless( $skin );
    $fname = $self->find_skin( $name );
    unless( $fname ) {
	print STDERR "$main'prog: WARNING: skin $name unknown (line $.)"; 
	return $skin;
    }

    if( (-s "$fname/cache") && (! $self->{"bypass_skincache"}) ) {
	print "reading skin from cache\n" if( $main::dl>4 );
	open( _CACHE, "<$fname/cache" );
	while( <_CACHE> ) {
	    chomp;
	    my( $var, $val ) = split( "\x00", $_, 2 );
	    $val =~ tr/\x00/\n/;
	    $skin->{$var} = $val;
	}
	close _CACHE;
	return $skin;
    }


    opendir( _DIR, $fname ) ||
	print STDERR "$main'prog: WARNING: cannot read directory $fname in line $. of config\n"; 
    foreach $file (readdir( _DIR )) {
	if( $file =~ /\.(proto|inc|sub)$/ ) {
	    $skin->{$file} = "";
	    open( _F, "<${fname}$file" );
	    while( <_F> ) {
		$skin->{$file} .= $_;
	    }
	    $skin->{$file} =~ s/\\\n$//;
	    close( _F );
	    $skin->{"T.".$file} = "file";
	}
	else {
	    $skin->{$file} = $fname.$file;
	    $skin->{$file} =~ s#^\Q$main::root/www/##;
	    $skin->{"T.".$file} = "url";
	}
    }
    closedir( _DIR );
    return $skin;
}


sub cache_skin {
    my( $self, $name, $skin ) = @_;
    my( $dir, $fname, $file );
    my( $var, $val );

    print STDERR "cache_skin( $name )\n" if( $main::dl>2 );
    $skin = {} unless( $skin );
    $fname = $self->find_skin( $name );
    unless( $fname ) {
	print STDERR "$main'prog: WARNING: skin $name unknown"; 
	return undef;
    }
    open( OUT, ">$fname/cache" );
    while( ($var,$val) = each %$skin ) {
	$val =~ tr/\n/\x00/;
	print OUT $var."\x00".$val."\n";
    }
    close OUT;
}



sub encode {
    my( $self, $text ) = @_;
    my $trans;

    $trans = "";
    while( $text =~ /([^a-z0-9_\-])/ ) {
	$trans .= $`."%".sprintf("%x",ord($1));
	$text = $';
    }
    return $trans.$text;
}


1;
